#################
# profile nlogL #
#################
#psi.rho <- function(rho) 0.5*log((1+rho)/(1-rho))
#rho.psi <- function(psi) (exp(2*psi)-1)/(exp(2*psi)+1)



ar1PL <- function(param,yr,xr,N,T)
{
	k <- if(!is.null(xr)) ncol(xr) else 0
	rho<-param[k+1]
	lsigma2 <- param[k+2]
	beta <- if(!is.null(xr)) param[1:k]
	
	res <-if(!is.null(xr))  as.vector(yr - xr %*% beta)  else yr
	res <- matrix(res,nrow=N,ncol=T,byrow=TRUE)
	
	# Omega.inv
	O.inv <- matrix(0,T,T)
	diag(O.inv) <- 1+rho^2
	O.inv[1,1] <- O.inv[T,T] <- 1
	for (i in 2:T)
	{
		O.inv[i,i-1] <- O.inv[i-1,i] <- -rho
	}
	O.inv <- O.inv/exp(lsigma2)
	
	# (1_T^T O.inv 1_T)
	j.mumu <- exp(-lsigma2)*(T-rho*(T-2))*(1-rho)
	
	W <- O.inv%*%(diag(rep(1,T))-rep(1/j.mumu,T)%*%t(rep(1,T))%*%O.inv)
	# y^T W y !
	ss <- sum(apply(res,1,function(x) t(x)%*%W%*%x))
	
	out<- -0.5*(-N*T*lsigma2 + N*log(1-rho^2) -ss)
	
	return(out)
}



#############################################
# marginal nlogL (which coincides with MPL) #
#############################################


ar1MPL <- function(param,yr,xr,N,T)
{
	k <- if(!is.null(xr)) ncol(xr) else 0
	#rho <- psi.rho(param[k+1])
	rho <- param[k+1]
	lsigma2 <- param[k+2]
	beta <- if(!is.null(xr)) param[1:k]
	res <-if(!is.null(xr))  as.vector(yr - xr %*% beta) else yr	
	res <- matrix(res,nrow=N,ncol=T,byrow=TRUE)
	O.inv <- matrix(0,T,T)
	diag(O.inv) <- 1+rho^2
	O.inv[1,1] <- O.inv[T,T] <- 1
	for (i in 2:T)
	{
		O.inv[i,i-1] <- O.inv[i-1,i] <- -rho
	}

	O.inv <- O.inv/exp(lsigma2)
	
	j.mumu <- exp(-lsigma2)*(T-rho*(T-2))*(1-rho)
	
	W <- O.inv%*%(diag(rep(1,T))-rep(1/j.mumu,T)%*%t(rep(1,T))%*%O.inv)

	ss <- sum(apply(res,1,function(x) t(x) %*% W %*% x))
	
	out <- 0.5 * (-N * (T-1) * lsigma2 + N * log(1+rho) - N * log(T - rho * (T-2)) - ss)
	return(out)
}

ar1MPL.nlminb <- function(param,yr,xr,N,T) -1 * ar1MPL(param,yr,xr,N,T)
