#######################################################
#        Internal functions                           #
#######################################################
truncRegAlpha <- function(Xe,panel,y,beta,sigma,alpha.in=rep(0,length(unique(panel))))
{   
	 q<- length(unique(panel)) 
	 ng<- tapply(rep(1,nrow(Xe)), panel, sum) 
	 .C("trunc_reg_alpha",
	  as.double(alpha.in),
	  as.double(sigma),
     as.double(beta),
     as.double(Xe),
     as.integer(length(beta)),
     as.double(y),
     as.integer(nrow(Xe)),
     as.integer(ng),
     as.integer(q),
     as.integer(max(ng)),
     as.double(10^-6),
     as.integer(100),
     alpha=as.double(rep(0.0,q)),PACKAGE="panelMPL")$alpha
   }


#minus pl
truncRegPL <- function(theta,Xe,y,panel,alpha.in=rep(0,length(unique(panel))))
{    q<- length(unique(panel)) 
	 ng<- tapply(rep(1,nrow(Xe)), panel, sum) 
	 dimpar <- length(theta)
	 beta <- theta[-dimpar]
	 sigma <- exp(theta[dimpar])
	 .C("trunc_reg_PL",
	  as.double(alpha.in),
	  as.double(sigma),
     as.double(beta),
     as.double(Xe),
     as.integer(length(beta)),
     as.double(y),
     as.integer(nrow(Xe)),
     as.integer(ng),
     as.integer(q),
     as.integer(max(ng)),
     as.double(10^-6),
     as.integer(100),
     lP=as.double(0),PACKAGE="panelMPL")$lP
   }


###  prof mod lik with the right sign
truncRegMPL <- function(theta,Xe,y,panel,alpha.in=rep(0,length(unique(panel))))
{    
	 q<- length(unique(panel)) 
	 ng<- tapply(rep(1,nrow(Xe)), panel, sum) 
	 dimpar <- length(theta)
	 beta <- theta[-dimpar]
	 sigma <- exp(theta[dimpar])
	  out<- .C("trunc_reg_MPL",
	  as.double(alpha.in),
	  as.double(sigma),
     as.double(beta),
     as.double(Xe),
     as.integer(length(beta)),
     as.double(y),
     as.integer(nrow(Xe)),
     as.integer(ng),
     as.integer(q),
     as.integer(max(ng)),
     as.double(10^-6),
     as.integer(100),
     lM=as.double(0),PACKAGE="panelMPL")$lM
     return(-out)
   }









