\name{simu.panelMPL}
\alias{simu.panelMPL}
\title{Simulation of response variables for fixed-effects panel data models}
\description{supporting function for simulation studies}
\usage{ simu.panelMPL(X, panel, model, y0=NULL, beta, alpha, sigma=NULL, rho=NULL)  }
\arguments{
  \item{X}{
  	design matrix with  \eqn{N T}{N T} rows,  containing the	 panel-varying covariates.
  	    }
  \item{panel}{panel indicator (factor or numeric).
}
  \item{model}{
  	character specification of the model. Currently, \code{"dynLogit"}, \code{"dynProbit"},
    \code{"statLogit"}, \code{"statProbit"}, \code{"truncReg"}, \code{"ar1"} are supported.
}
 \item{y0}{
       vector of size \eqn{N \times 1}{N x 1}  with the first observation for each panel. Only used by
       for \code{"dynLogit"} or \code{"dynProbit"} models.
}
  \item{beta}{coefficients of design matrix columns.
}
\item{alpha}{panel-specific intercepts.
}
\item{rho}{coefficient of lagged response. Only for  \code{"dynLogit"} or \code{"dynProbit"} models.
}
 \item{sigma}{standard deviation of untruncated response. Only for  \code{"truncReg"} model.
}
   }

\value{
 a vector of size \eqn{N T \times 1}{N T x 1}, the simulated response.  
}


\references{Bartolucci, F., Bellio, R., Salvan, A., Sartori, N. (2015). "Modified Profile Likelihood for Fixed-Effects Panel Data Models", 
Econometric Reviews.}



\author{
Ruggero Bellio and Nicola Sartori.
}

\seealso{
 \code{\link{panelMPL}}.
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{models}
\keyword{regression}